/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 *
 *  This file is part of GNU Classpath.
 *
 *  GNU Classpath is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  GNU Classpath is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Classpath; see the file COPYING.  If not, write to the
 *  University of Warsaw, Interdisciplinary Centre for Mathematical and
 *  Computational Modelling, Pawinskiego 5a, 02-106 Warsaw, Poland.
 *
 *  Linking this library statically or dynamically with other modules is
 *  making a combined work based on this library.  Thus, the terms and
 *  conditions of the GNU General Public License cover the whole
 *  combination.
 *
 *  As a special exception, the copyright holders of this library give you
 *  permission to link this library with independent modules to produce an
 *  executable, regardless of the license terms of these independent
 *  modules, and to copy and distribute the resulting executable under
 *  terms of your choice, provided that you also meet, for each linked
 *  independent module, the terms and conditions of the license of that
 *  module.  An independent module is a module which is not derived from
 *  or based on this library.  If you modify this library, you may extend
 *  this exception to your version of the library, but you are not
 *  obligated to do so.  If you do not wish to do so, delete this
 *  exception statement from your version.
 */
 
package org.visnow.vn.lib.basic.filters.hough;

import org.visnow.jscic.RegularField;

/**
 * @author Michał Łyczek (lyczek@icm.edu.pl)
 * University of Warsaw, Interdisciplinary Centre
 * for Mathematical and Computational Modelling
 */
public class GUI extends javax.swing.JPanel
{

    private Params params = new Params();
    private RegularField inField = null;

    /**
     * Creates new form GUI
     */
    public GUI()
    {
        initComponents();
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        holdButton = new javax.swing.JToggleButton();

        holdButton.setText("Hold");
        holdButton.setName("holdButton"); // NOI18N
        holdButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                holdButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
                layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addGroup(layout.createSequentialGroup()
                                .addContainerGap()
                                .addComponent(holdButton)
                                .addContainerGap(234, Short.MAX_VALUE))
                );
        layout.setVerticalGroup(
                layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addGroup(layout.createSequentialGroup()
                                .addContainerGap()
                                .addComponent(holdButton)
                                .addContainerGap(357, Short.MAX_VALUE))
                );
    }// </editor-fold>//GEN-END:initComponents

    private void holdButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_holdButtonActionPerformed
        update();
    }//GEN-LAST:event_holdButtonActionPerformed

    public void setParams(Params params)
    {
        this.params = params;
    }

    public void setInField(RegularField field)
    {
        if (field == null || field.getDims().length < 2 || field.getNComponents() < 1) {
            inField = null;
            updateGUI();
            return;
        }

        this.inField = field;
        holdButton.setSelected(true);
        updateGUI();
        holdButton.setSelected(false);
    }

    private void update()
    {
        if (inField == null) {
            return;
        } else {
            //            params.setLowerThreshold(thresholdSlider.getBottomValue());
            //            params.setUpperThreshold(thresholdSlider.getTopValue());
        }
        if (!holdButton.isSelected()) {
            params.fireStateChanged();
        }
    }

    private void updateGUI()
    {
        if (inField == null) {

            //            thresholdSlider.setEnabled(false);
            //            thresholdSlider.setMaximum(255);
            //            thresholdSlider.setMinimum(0);
            //            lowerThresholdTF.setEnabled(false);
            //            upperThresholdTF.setEnabled(false);
        } else {
            //            thresholdSlider.setEnabled(true);
            //            thresholdSlider.setMaximum((int) getMax());
            //            thresholdSlider.setMinimum((int) getMin());
            //            thresholdSlider.setBottomValue(params.getLowerThreshold());
            //            thresholdSlider.setTopValue(params.getUpperThreshold());
            //            lowerThresholdTF.setEnabled(true);
            //            lowerThresholdTF.setText("" + thresholdSlider.getBottomValue());
            //            upperThresholdTF.setEnabled(true);
            //            upperThresholdTF.setText("" + thresholdSlider.getTopValue());
        }
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JToggleButton holdButton;
    // End of variables declaration//GEN-END:variables
}
